from Crypto.Cipher import AES
import hashlib
import SocketServer
import base64

def to_int(string):
    return int(string.encode("hex"), 16)

def hash(string):
    return to_int(hashlib.sha256(str(string)).digest())

def hmac(string):
    try:
        val = int(string)
    except ValueError:
        val = to_int(string)
    #Handle the exception
    key = to_int("flag{n00bHMAc}")
    tmp = key ^ val
    return hash(tmp + val)

class MyTCPHandler(SocketServer.BaseRequestHandler):
    def handle(self):
        self.request.send("Enter your input: ")

        while True:
            self.data = self.request.recv(1024)
            if(len(self.data) == 1):
                self.request.send("Empty string is invalid!!!")
            else:
                self.data = self.data[:-1]
                tmp = hmac(self.data)
                self.request.send("HMAC: " + str(tmp))
            self.request.send("\nEnter your input: ")

    def finish(self):
        print 'Client Leaving.... and Left !!!'

if __name__ == '__main__':
    pair = 'localhost', 8085
    # Allow fast recycle and reusing
    SocketServer.TCPServer.allow_reuse_address = True
    server = SocketServer.TCPServer(pair, MyTCPHandler)
    SocketServer.TCPServer.allow_reuse_address = True
    print 'Server started'
    server.serve_forever()
