# [START app]
import os
import json

from flask import Flask, request, make_response, abort, send_file, jsonify, send_from_directory, render_template_string, render_template, g
from flask_limiter import Limiter
from flask_limiter.util import get_remote_address

app = Flask(__name__)
limiter = Limiter(app, key_func=get_remote_address)

@app.route("/")
@limiter.limit("100/minute", error_message="flag{Denial of service}")
def secret():
    return "I am sensitive to your requests. I need time to process them"

# [START Handling error]
@app.errorhandler(500)
def server_error(e):
    return make_response(jsonify({'error': 'An error occurred during a request'}), 400)

@app.errorhandler(400)
def bad_request(error):
    return make_response(jsonify({'error': 'Bad request'}), 400)


@app.errorhandler(404)
def not_found(error):
    return make_response(jsonify({'error': 'Not found'}), 404)
# [END Handling error]

if __name__ == '__main__':
    app.run(host='127.0.0.1', port=8084, debug=False)
# [END app]
